//******************************************************************************
//! @file $RCSfile: isp_lib.c,v $
//!
//! Copyright (c) 2009 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧قAT90CAN128/64/32ATmega16M1/32M1/32C1/64M1/64C1pɗp
//!		   \ISPٰ݂܂݂܂B
//!
//! ̧وȉŊmFĂ܂B
//! - AVRStudio 4.15.623,
//! - IAR AVRpC/C++߲ 5.20.1 (5.20.1.50092)
//!
//! @version $Revision: 3.00 $ $Name: jtellier $
//!
//! @todo
//! @bug
//******************************************************************************

//_____ ݸٰ ________________________________________________________________
#include "config.h"
#include "isp_lib.h"
#include "flash_boot_lib.h"
#include "eeprom_lib.h"

//_____ ` ___________________________________________________________________

//_____ 錾 _______________________________________________________________

//----------------------------------------------------------------------------..
// : BOOT_CONFz͈قȂ߰ł߂ɐp(:flash_wr_ ||
//	   block()֐)łłȂ΂Ȃ܂B͐޲Ă̂Ɉȉ̒iK ||
//	   KvȂƂłB														  ||
//!		- Fill_Temporary_Buffer (size=1߰ޒ)								  ||
//!		- Erase_Page														  ||
//!		- Program_Page														  ||
//!		޲Ă֐߰ޓ̏ꍇAProgram_Pagȅꏊŋ󔒌ꂪ擾 ||
//!		߁AErase_PageProgram_pageז܂!!!B					  ||
//----------------------------------------------------------------------------''
#pragma location ="BOOT_CONF"
U8   _BOOT_CONF_TYPE_  boot_conf[]  = {
            BSB_DEFAULT , SSB_DEFAULT , EB_DEFAULT ,
            BTC1_DEFAULT, BTC2_DEFAULT, BTC3_DEFAULT,
            NNB_DEFAULT,  CRIS_DEFAULT,
            SA_H_DEFAULT, SA_L_DEFAULT               };

//_____ 錾 ___________________________________________________________________

U8          isp_select_memory;
U8          isp_select_page;

U16         isp_start_address;
U16         isp_number_of_bytes;		// 0x0001=1޲ā`0xFFFF=65535޲
U16         isp_start_address_copy;
U16         isp_number_of_bytes_copy;

Bool        isp_prog_on_going;

U8   boot_conf_default[]  = {
            BSB_DEFAULT , SSB_DEFAULT , EB_DEFAULT ,
            BTC1_DEFAULT, BTC2_DEFAULT, BTC3_DEFAULT,
            NNB_DEFAULT,  CRIS_DEFAULT,
            SA_H_DEFAULT, SA_L_DEFAULT               };


//_____ ֐ ___________________________________________________________________

//------------------------------------------------------------------------------
//  @fn isp_jump_to
//!
//! ̊֐ISPK񂩂痈"ѐ"𕪐͂܂B
//!
//! @warning	Ȃ
//!
//! @param:	jump_addr	ѐڽ
//!
//! @return	Ȃ
//!
//------------------------------------------------------------------------------
void  isp_jump_to(U16 jump_addr)
{
  if (jump_addr <= ((FLASHEND - BOOT_LOADER_SIZE)>>1) )
  {
	Indirect_jump_to(jump_addr);	// pJn
  }
  else
  {
	Direct_jump_to_zero();			// ڽ0x00000牞pJn
  }
}

//------------------------------------------------------------------------------
//  @fn isp_set_memory
//!
//! ̊֐ISPK񂩂痈ؕ𕪐͂Đݒ肵܂B
//!
//! @warning	Ȃ
//!
//! @param:	mem_code	ؕ(0`MEM_DEF_MAX)
//!
//! @return	Ȃ
//!
//------------------------------------------------------------------------------
void  isp_set_memory(U8 mem_code)
{
  isp_select_memory = mem_code;
}

//------------------------------------------------------------------------------
//  @fn isp_set_page
//!
//! ̊֐ISPK񂩂痈߰ޔԍ𕪐͂Đݒ肵܂B
//!
//! @warning	ׯ ؋Ԃ0ȊO߰ޔԍĂ܂B
//!
//! @param:	page_nb	߰ޔԍ
//!
//! @return	Ȃ
//!
//------------------------------------------------------------------------------
void  isp_set_page(U8 page_nb)
{
  isp_select_page = page_nb;
}

//------------------------------------------------------------------------------
//  @fn isp_address_range
//!
//! ̊֐ISPK񂩂痈64K͈͓"isp_start_address""isp_number_of_bytes"
//! 𕪐͂Đݒ肵܂B
//!
//! @warning:	1 - 64K͈͓"isp_start_address"
//!				2 - "isp_number_of_bytes": 0x0001=1`0xFFFF=65535޲
//!
//! @param:	start_addr = 64K͈͓̊Jn޲ ڽ
//!			end_addr   = 64K͈͓̏I޲ ڽ
//!
//! @return	Ȃ
//!
//------------------------------------------------------------------------------
void  isp_address_range(U16 start_addr, U16 end_addr)
{
  isp_start_address = start_addr;
  isp_number_of_bytes = (end_addr - start_addr) + 1;
}

//------------------------------------------------------------------------------
//  @fn isp_memory_erase
//!
//! ̊֐ISPK񂩂痈镄ԍőIꂽ؂(ꂪ\Ȃ)S
//! s܂B
//!
//! @warning:	1 - ؂̂"ǂݍݐp"łB
//!				2 - ׯ ؏Ϳĳی޲"SSB(Software Security Byte)
//!					"SSB_NO_SECURITY"ɐݒ肵܂B
//!				3 - ް ۰ތ`Ԑݒ("SSB"ɂĐ䂳)"ް ۰ތ`
//!					Ԑݒ"ŏ܂B
//!
//! @param	Ȃ
//!
//! @return:	0 = ߗL
//!				1 = ߎs(یݒ)܂"ǂݍݐp"
//!
//------------------------------------------------------------------------------
Bool  isp_memory_erase(void)
{
  Bool    rtn = 1;

  switch (isp_select_memory)
  {

	//- ׯ  -----------------------------------------------------------
	case (MEM_FLASH):
	  flash_full_erase();
#	if defined(_RAMPZ_IS_USED_)
	  RAMPZ = 1;
#	endif
	  flash_wr_byte((U16)(&SSB), SSB_NO_SECURITY);	//- x[Pe767]: ߲菬^ւ̕ϊ
#	if defined(_RAMPZ_IS_USED_)
	  RAMPZ = isp_select_page;
#	endif
	  break;

	//- EEPROM ----------------------------------------------------------
	case (MEM_EEPROM):
	  if(SSB == SSB_NO_SECURITY)
	  {
		eeprom_full_erase();
	  }
	  else rtn=0;
#	if defined(_RAMPZ_IS_USED_)		//- : ̉SSBRAMPZj󂵓܂B
	  RAMPZ = isp_select_page;
#	endif
	  break;

	//- ް ۰ތ`Ԑݒ ----------------------------------------------
	case (MEM_BOOT_CONF):
	  if(SSB == SSB_NO_SECURITY)
	  {
#	if defined(_RAMPZ_IS_USED_)
	  RAMPZ = 0x01;
#	endif
	  flash_wr_block(boot_conf_default, (U16)(boot_conf), BOOT_CONF_SIZE);	//- x[Pe767]: ߲菬^ւ̕ϊ
#	if defined(_RAMPZ_IS_USED_)
	  RAMPZ = isp_select_page;
#	endif
	  }
	  else rtn=0;
	  break;

	//- ̑"ǂݍݐp" -------------------------------------------------
	default:
	  rtn = 0;
	  break;
  }
  return(rtn);
}

//------------------------------------------------------------------------------
//  @fn isp_read_block
//!
//! ̊֐͑I("isp_select_memory")̑I߰("isp_select_page")
//! ̊Jnڽ("isp_start_address")(ҰƂēnꂽɏՕ̗eʂ)P
//! ʂŎw޲Đ("isp_number_of_bytes")̓ǂݍ݂s܂B
//!
//! @warning:	̊֐ҰƂēnꂽɏՕ̗eʂɏ]"isp_start_add
//!				ress""isp_number_of_bytes"œ܂BA֐Ăяo͏
//!				̒l񕜂邽߂̕ǗCĂ܂B
//!
//! @param:	- isp_buffer	= ްo͗p̉
//!			- size			= isp_buffer̗e
//!
//! @return:	0x00 = p\"isp_read_block()"Ɠ]͏I܂łB
//!				0x01 = "isp_read_block()"ŏỈł̌"isp_number_of_bytes"
//!					   ̍ŏI̗ʂƓʂłB
//!				0xFF = ĳی޲ĐݒAǂݍݗps
//!
//------------------------------------------------------------------------------
U8  isp_read_block(U8* isp_buffer, U16 size)
{
  U16  i;
  U8   rtn = 0x00;

  switch (isp_select_memory)
  {
	//- ׯ  -----------------------------------------------------------
	case (MEM_FLASH):
	  if( (SSB == SSB_NO_SECURITY) || (SSB == SSB_WR_PROTECTION) )
	  {
#	  if defined(_RAMPZ_IS_USED_)					//- : ̉SSBRAMPZj󂵓܂B
		RAMPZ = isp_select_page;
#	  endif
		if (size !=0)								//- 64KȊO
		{
		  size = Min (size, isp_number_of_bytes);	//- "compiler.h"łϸ
		}
		for (i=0; i< size; i++)
		{
		  isp_buffer[i] = flash_rd_byte(isp_start_address);
		  isp_start_address++;
		  isp_number_of_bytes--;
		}
		if (isp_number_of_bytes == 0)
		{
		  isp_number_of_bytes = size;
		  rtn = 0x01;
		}
	  }
	  else rtn = 0xFF;
	  break;
	//- EEPROM ----------------------------------------------------------
	case (MEM_EEPROM):
	  if( (SSB == SSB_NO_SECURITY) || (SSB == SSB_WR_PROTECTION) )
	  {
#	  if defined(_RAMPZ_IS_USED_)					//- : ̉SSBRAMPZj󂵓܂B
		RAMPZ = isp_select_page;
#	  endif
		size = Min (size, isp_number_of_bytes);		//- "compiler.h"łϸ
		for (i=0; i< size; i++)
		{
		  isp_buffer[i] = eeprom_rd_byte(isp_start_address);
		  isp_start_address++;
		  isp_number_of_bytes--;
		}
		if (isp_number_of_bytes == 0)
		{
		  isp_number_of_bytes = size;
		  rtn = 0x01;
		}
	  }
	  else rtn = 0xFF;
	  break;
	//- ޲[ -------------------------------------------------------
	case (MEM_SIGNATURE):							//- (ő4޲)
	  size = Min (size, isp_number_of_bytes);		//- "compiler.h"łϸ
	  for (i=0; i< size; i++)
	  {
		if      ( isp_start_address == 0 ) isp_buffer[i] = MANUF_ID;
		else if ( isp_start_address == 1 ) isp_buffer[i] = FAMILY_CODE;
		else if ( isp_start_address == 2 ) isp_buffer[i] = PRODUCT_NAME;
		else                               isp_buffer[i] = PRODUCT_REV;
		isp_start_address++;
		isp_number_of_bytes--;
	  }
	  if (isp_number_of_bytes == 0)
	  {
		isp_number_of_bytes = size;
		rtn = 0x01;
	  }
	  break;
	//- ް ۰ޏ ------------------------------------------------
	case (MEM_BOOT_INF):							//- (ő3޲)
	  size = Min (size, isp_number_of_bytes);		//- "compiler.h"łϸ
	  for (i=0; i< size; i++)
	  {
		if      ( isp_start_address == 0 ) isp_buffer[i] = BOOT_VERSION;
		else if ( isp_start_address == 1 ) isp_buffer[i] = BOOT_ID1;
		else                               isp_buffer[i] = BOOT_ID2;
		isp_start_address++;
		isp_number_of_bytes--;
	  }
	  if (isp_number_of_bytes == 0)
	  {
		isp_number_of_bytes = size;
		rtn = 0x01;
	  }
	  break;
	//- ް ۰ތ`Ԑݒ ----------------------------------------------
	case (MEM_BOOT_CONF):
	  size = Min (size, isp_number_of_bytes);		//- "compiler.h"łϸ
	  for (i=0; i< size; i++)
	  {
		isp_buffer[i] = boot_conf[isp_start_address];
		isp_start_address++;
		isp_number_of_bytes--;
	  }
	  if (isp_number_of_bytes == 0)
	  {
		isp_number_of_bytes = size;
		rtn = 0x01;
	  }
#	if defined(_RAMPZ_IS_USED_)						//- : ̉boot_conf[]RAMPZj󂵓܂B
	  RAMPZ = isp_select_page;
#	endif
	  break;
	//- ޲ ڼ޽ -------------------------------------------------------
	case (MEM_HW_REG):
	  size = Min (size, isp_number_of_bytes);		//- "compiler.h"łϸ
	  for (i=0; i< size; i++)
	  {
		isp_buffer[i] = REGISTER_BYTE_AT(isp_start_address);
		isp_start_address++;
		isp_number_of_bytes--;
	  }
	  if (isp_number_of_bytes == 0)
	  {
		isp_number_of_bytes = size;
		rtn = 0x01;
	  }
	  break;
	//- ȏ،`Ȃ -------------------------------------------------
	default:
	  rtn = 0xFF;
	  break;
  } // switch (isp_sel...
  return(rtn);
}

//------------------------------------------------------------------------------
//  @fn isp_blank_check
//!
//! ̊֐͑I("isp_select_memory")ƑI߰("isp_select_page")
//! ̊Jnڽ("isp_start_address")w޲Đ("isp_number_of_bytes")̋
//! s܂B
//!
//! @warning	Ȃ
//!
//! @param	Ȃ
//!
//! @return:	TRUE  (1) = ُȂA͈ؔ͂͋
//!				FALSE (0) = "isp_blank_check()"ُ, "isp_start_address"͋󔒂
//!							łȂŏ޲Ă̱ڽƓłB
//!
//------------------------------------------------------------------------------
Bool  isp_blank_check(void)
{
  Bool    rtn = TRUE;

  switch (isp_select_memory)
  {

	//- ׯ  -----------------------------------------------------------
	case (MEM_FLASH):
#	if defined(_RAMPZ_IS_USED_)
	  RAMPZ = isp_select_page;
#	endif
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//- ύX -
//================
//- JT 2006N413
//- 64K܂łǗ邽߂Transform "for(...;...;...)""while(1)"ŕό`
//-
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	  while(1)	//- 64K܂łvZ邽߂̓
	  {
		if ( (flash_rd_byte(isp_start_address)) != ((U8)(FLASH_BLANK_WORD)) )
		{
		  rtn = FALSE;
		   break;								//- whileo
		}
		isp_start_address++;
		isp_number_of_bytes--;
		if (isp_number_of_bytes == 0) break;	//- while̕WIȔo
	  }
	  break;
	//- EEPROM ----------------------------------------------------------
	case (MEM_EEPROM):
	  while(1)
	  {
		if ( (eeprom_rd_byte(isp_start_address)) != EEPROM_BLANK_BYTE )
		{
		  rtn = FALSE;
		  break;								//- whileo
		}
		isp_start_address++;
		isp_number_of_bytes--;
		if (isp_number_of_bytes == 0) break;	//- while̕WIȔo
	  }
	  break;
	//- ް ۰ތ`Ԑݒ ----------------------------------------------
	case (MEM_BOOT_CONF):
	  while(1)
	  {
#	  if defined(_RAMPZ_IS_USED_)
		RAMPZ = 0x01;
#	  endif
		if ( boot_conf[isp_start_address] != boot_conf_default[isp_start_address] )
		{
		  rtn = FALSE;
		  break;								//- whileo
		}
		isp_start_address++;
		isp_number_of_bytes--;
		if (isp_number_of_bytes == 0) break;	//- while̕WIȔo
	  }
#	if defined(_RAMPZ_IS_USED_)					//- : ̉boot_conf[]RAMPZj󂵓܂B
	  RAMPZ = isp_select_page;
#	endif
	  break;
	//- ̑͂̒`Ɠ -----------------------------------
	default:
	  break;
  } // switch (isp_sel...
  return(rtn);
}

//------------------------------------------------------------------------------
//  @fn isp_prog_block
//!
//! ̊֐͑I("isp_select_memory")ƑI߰("isp_select_page")
//! ̊Jnڽ("isp_start_address")(ҰƂēnꂽɏՕ̗eʂ)P
//! ʂŎw޲Đ("isp_number_of_bytes")݂̏s܂B
//!
//! @warning:	̊֐ҰƂēnꂽɏՕ̗eʂɏ]"isp_start_add
//!				ress""isp_number_of_bytes"œ܂BA֐Ăяo͏
//!				̒l񕜂邽߂̕ǗCĂ܂B
//!
//! @param:	- isp_buffer	= ް͗p
//!			- size			= isp_buffer̗e
//!
//! @return:	0x00 = "isp_prog_block()"򏑂݊A]͏I܂
//!					   B
//!				0x01 = "isp_prog_block()"Ō̉A"isp_number_of_bytes"͂
//!					   Ō̗̉ʂƓłB
//!				0xFF = ĳی޲ĐݒAݕs
//!
//------------------------------------------------------------------------------
U8  isp_prog_block(U8* isp_buffer, U16 size)
{
  U8  rtn = 0x00;

  switch (isp_select_memory)
  {
	//- ׯ  -----------------------------------------------------------
	case (MEM_FLASH):
	  if( SSB == SSB_NO_SECURITY )
	  {
#	  if defined(_RAMPZ_IS_USED_)					//- : ̉SSBRAMPZj󂵓܂B
		RAMPZ = isp_select_page;
#	  endif
		//- νĂKvƂ镪𐳊mɑ邽߁A(ǂݍ݂̂悤)ʌ͕Kv܂B
		flash_wr_block(isp_buffer, isp_start_address, size);
		isp_start_address += size;
		isp_number_of_bytes -= size;
		if (isp_number_of_bytes == 0) rtn = 0x01;
	  }
	  else rtn = 0xFF;
	  break;
	//- EEPROM ----------------------------------------------------------
	case (MEM_EEPROM):
	  if( SSB == SSB_NO_SECURITY )
	  {
#	  if defined(_RAMPZ_IS_USED_)					//- : ̉SSBRAMPZj󂵓܂B
		RAMPZ = isp_select_page;
#	  endif
		//- νĂKvƂ镪𐳊mɑ邽߁A(ǂݍ݂̂悤)ʌ͕Kv܂B
		eeprom_wr_block(isp_buffer, isp_start_address, size);
		isp_start_address += size;
		isp_number_of_bytes -= size;
		if (isp_number_of_bytes == 0) rtn = 0x01;
	  }
	  else rtn = 0xFF;
	  break;
	//- ް ۰ތ`Ԑݒ ----------------------------------------------
	case (MEM_BOOT_CONF):
#	if defined(_RAMPZ_IS_USED_)
	  RAMPZ = 0x01;
#	endif
	  //- νĂKvƂ镪𐳊mɑ邽߁A(ǂݍ݂̂悤)ʌ͕Kv܂B
	  if( SSB == SSB_NO_SECURITY )
	  {
		flash_wr_block(isp_buffer, ( isp_start_address + ((U16)(boot_conf)) ), size);	//- x[Pe767]: ߲菬^ւ̕ϊ
		isp_start_address += size;
		isp_number_of_bytes -= size;
		if (isp_number_of_bytes == 0) rtn = 0x01;
	  }
	  else if ( (SSB == SSB_WR_PROTECTION) && \
				(isp_start_address == SSB_INDEX) && \
				(size == 1) && (isp_buffer[0] == SSB_RD_WR_PROTECTION ) )
	  {
		flash_wr_byte(((U16)(&SSB)), SSB_RD_WR_PROTECTION);		//- x[Pe767]: ߲菬^ւ̕ϊ
		rtn = 0x01;
	  }
	  else rtn = 0xFF;
#	if defined(_RAMPZ_IS_USED_)
	  RAMPZ = isp_select_page;
#	endif
	  break;
	//- ݱłȏ،`Ȃ ---------------------------------
	default:
	  rtn = 0xFF;
	  break;
  } // switch (isp_sel...
  return(rtn);
}
