//******************************************************************************
//! @file $RCSfile: isp_lib.h,v $
//!
//! Copyright (c) 2009 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧قAT90CAN128/64/32ATmega16M1/32M1/32C1/64M1/64C1ŗp\
//!		   ISPٰ݂̑SĂ̌^ϸۂ܂݂܂B
//!
//! ̧وȉŊmFĂ܂B
//! - AVRStudio 4.15.623,
//! - IAR AVRpC/C++߲ 5.20.1 (5.20.1.50092)
//!
//! @version $Revision: 3.00 $ $Name: jtellier $
//!
//! @todo
//! @bug
//******************************************************************************

#ifndef _ISP_LIB_H_
#define _ISP_LIB_H_

//_____ ݸٰ ________________________________________________________________

//_____ ` ___________________________________________________________________
#define REGISTER_BYTE_AT	*(U8 volatile*)

//----------- ް۰ގʒ` ----
// ް ؒ`
#define BOOT_VERSION	0x04	// Ver 04: JT-2009N46
#define BOOT_ID1		0xD1
#define BOOT_ID2		0xD2

#define BSB_DEFAULT		0xFF
#define SSB_DEFAULT		0xFF
#define EB_DEFAULT		0xFF
#define BTC1_DEFAULT	0xFF
#define BTC2_DEFAULT	0xFF
#define BTC3_DEFAULT	0xFF
#define NNB_DEFAULT		0xFF
#define CRIS_DEFAULT	0x00
#define SA_H_DEFAULT	0x00
#define SA_L_DEFAULT	0x00

#define BSB		boot_conf[0]
#define SSB		boot_conf[1]
#define EB		boot_conf[2]
#define BTC1	boot_conf[3]
#define BTC2	boot_conf[4]
#define BTC3	boot_conf[5]
#define NNB		boot_conf[6]
#define CRIS	boot_conf[7]
#define SA_H	boot_conf[8]
#define SA_L	boot_conf[9]

#define BOOT_CONF_SIZE			  10
#define SSB_INDEX				0x01
#define SSB_NO_SECURITY			0xFF
#define SSB_WR_PROTECTION		0xFE
#define SSB_RD_WR_PROTECTION	0xFC

//-------- ؒ` -----------------
#define MEM_FLASH		0
#define MEM_EEPROM		1
#define MEM_SIGNATURE 	2
#define MEM_BOOT_INF	3		// ް ۰ޏ
#define MEM_BOOT_CONF	4		// ް ۰ތ`Ԑݒ
#define MEM_HW_REG		5
#define MEM_DEFAULT		MEM_FLASH
#define MEM_DEF_MAX		MEM_HW_REG

#define PAGE_DEFAULT	0x00
#define ADD_DEFAULT		0x0000
#define N_DEFAULT		0x0001

#if defined(__HAS_ELPM__)		// IAR޲Iɂ__HAS_ELPM__`Ă΁A
# define MAX_NUMBER_OF_PAGE	2
#else							// __HAS_ELPM__`ĂȂ΁A
# define MAX_NUMBER_OF_PAGE	1
#endif

//_____ 錾 ___________________________________________________________________

extern U8   _BOOT_CONF_TYPE_  boot_conf[];
extern U8   isp_select_memory;
extern U8   isp_select_page;
extern U16  isp_start_address;
extern U16  isp_number_of_bytes;
extern U16  isp_start_address_copy;
extern U16  isp_number_of_bytes_copy;
extern Bool isp_prog_on_going;

//------------------------------------------------------------------------------
//  @fn isp_jump_to
//!
//! ̊֐ISPK񂩂痈"ѐ"𕪐͂܂B
//!
//! @warning	Ȃ
//!
//! @param:	jump_addr	ѐڽ
//!
//! @return	Ȃ
//!
extern void  isp_jump_to(U16 jump_addr);

//------------------------------------------------------------------------------
//  @fn isp_set_memory
//!
//! ̊֐ISPK񂩂痈ؕ𕪐͂Đݒ肵܂B
//!
//! @warning	Ȃ
//!
//! @param:	mem_code	ؕ(0`MEM_DEF_MAX)
//!
//! @return	Ȃ
//!
extern void  isp_set_memory(U8 mem_code);

//-----------------------------------------------------------------------------
//  @fn isp_set_page
//!
//! ̊֐ISPK񂩂痈߰ޔԍ𕪐͂Đݒ肵܂B
//!
//! @warning	ׯ ؋Ԃ0ȊO߰ޔԍĂ܂B
//!
//! @param:	page_nb	߰ޔԍ
//!
//! @return	Ȃ
//!
extern void  isp_set_page(U8 page_nb);

//------------------------------------------------------------------------------
//  @fn isp_address_range
//!
//! ̊֐ISPK񂩂痈64K͈͓"isp_start_address""isp_number_of_bytes"
//! 𕪐͂Đݒ肵܂B
//!
//! @warning:	1 - 64K͈͓"isp_start_address"
//!				2 - "isp_number_of_bytes": 0x0001=1`0xFFFF=65535޲
//!
//! @param:	start_addr = 64K͈͓̊Jn޲ ڽ
//!			end_addr   = 64K͈͓̏I޲ ڽ
//!
//! @return	Ȃ
//!
extern void  isp_address_range(U16 start_addr, U16 end_addr);

//------------------------------------------------------------------------------
//  @fn isp_memory_erase
//!
//! ̊֐ISPK񂩂痈镄ԍőIꂽ؂(ꂪ\Ȃ)S
//! s܂B
//!
//! @warning:	1 - ؂̂"ǂݍݐp"łB
//!				2 - ׯ ؏Ϳĳی޲"SSB(Software Security Byte)
//!					"SSB_NO_SECURITY"ɐݒ肵܂B
//!				3 - ް ۰ތ`Ԑݒ("SSB"ɂĐ䂳)"ް ۰ތ`
//!					Ԑݒ"ŏ܂B
//!
//! @param	Ȃ
//!
//! @return:	0 = ߗL
//!				1 = ߎs(یݒ)܂"ǂݍݐp"
//!
extern Bool  isp_memory_erase(void);

//------------------------------------------------------------------------------
//  @fn isp_read_block
//!
//! ̊֐͑I("isp_select_memory")̑I߰("isp_select_page")
//! ̊Jnڽ("isp_start_address")(ҰƂēnꂽɏՕ̗eʂ)P
//! ʂŎw޲Đ("isp_number_of_bytes")̓ǂݍ݂s܂B
//!
//! @warning:	̊֐ҰƂēnꂽɏՕ̗eʂɏ]"isp_start_add
//!				ress""isp_number_of_bytes"œ܂BA֐Ăяo͏
//!				̒l񕜂邽߂̕ǗCĂ܂B
//!
//! @param:	- isp_buffer	= ްo͗p̉
//!			- size			= isp_buffer̗e
//!
//! @return:	0x00 = p\"isp_read_block()"Ɠ]͏I܂łB
//!				0x01 = "isp_read_block()"ŏỈł̌"isp_number_of_bytes"
//!					   ̍ŏI̗ʂƓʂłB
//!				0xFF = ĳی޲ĐݒAǂݍݗps
//!
extern U8  isp_read_block(U8* isp_buffer, U16 size);

//------------------------------------------------------------------------------
//  @fn isp_blank_check
//!
//! ̊֐͑I("isp_select_memory")ƑI߰("isp_select_page")
//! ̊Jnڽ("isp_start_address")w޲Đ("isp_number_of_bytes")̋
//! s܂B
//!
//! @warning	Ȃ
//!
//! @param	Ȃ
//!
//! @return:	TRUE  (1) = ُȂA͈ؔ͂͋
//!				FALSE (0) = "isp_blank_check()"ُ, "isp_start_address"͋󔒂
//!							łȂŏ޲Ă̱ڽƓłB
//!
extern Bool  isp_blank_check(void);

//------------------------------------------------------------------------------
//  @fn isp_prog_block
//!
//! ̊֐͑I("isp_select_memory")ƑI߰("isp_select_page")
//! ̊Jnڽ("isp_start_address")(ҰƂēnꂽɏՕ̗eʂ)P
//! ʂŎw޲Đ("isp_number_of_bytes")݂̏s܂B
//!
//! @warning:	̊֐ҰƂēnꂽɏՕ̗eʂɏ]"isp_start_add
//!				ress""isp_number_of_bytes"œ܂BA֐Ăяo͏
//!				̒l񕜂邽߂̕ǗCĂ܂B
//!
//! @param:	- isp_buffer	= ް͗p
//!			- size			= isp_buffer̗e
//!
//! @return:	0x00 = "isp_prog_block()"򏑂݊A]͏I܂
//!					   B
//!				0x01 = "isp_prog_block()"Ō̉A"isp_number_of_bytes"͂
//!					   Ō̗̉ʂƓłB
//!				0xFF = ĳی޲ĐݒAݕs
//!
extern U8  isp_prog_block(U8* isp_buffer, U16 size);

//******************************************************************************

#endif  // _ISP_LIB_H_
